/*
 * lab1.c
 */

#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>

char colors[] = "ROGAVT";
int i;

void print_color()
{
	// linia 1
	char line1[15] = "Temp: ... C";
	LCD_printAt(0x00, line1);
	
	// linia 2
	char line2[15] = "Mod: ";
	line2[5] = colors[i];
	LCD_printAt(0x40, line2);

    _delay_ms(500);
}

void port_init()
{
	// configurare porturi folosite
	// led  PB5 → B, PB6 → G, PB7 → R;
	DDRA |= ((1 << PB5) | (1 << PB6) | (1 << PB7));
	
	// temp in PD0 → OUT
	DDRD &= ~(1 << PD0);
	PORTD |= (1 << PD0);
}

void complex_lcd()
{
	for(;;)
    {
		// verifica sunet
		if ((PIND & (1 << PD0)) == 1) {
			// schimba modul
			i++;
			if (i == 6)
				i = 0;
		
			// culoare led
			switch(i){
				case 0:// Rosu
					PORTB |= (1 << PB7);
					break;
					
				case 1:// O Portocaliu
					PORTB |= (1 << PB6);
					break;
					
				case 2:// G Verde
					PORTB &= ~(1 << PB7);
					break;
					
				case 3:// Albastru
					PORTB &= ~(1 << PB6);
					PORTB |= (1 << PB5);
					break;
					
				case 4: // Violet
					PORTB |= (1 << PB7);
					break;
					
				case 5: // Temperatura
					PORTB &= ~(1 << PB5);
					PORTB &= ~(1 << PB7);
					break;		
			}
			// lcd text
			print_color();
		}
	}
}

int main()
{
    LCD_init();
	port_init();
	i = -1;
	
	complex_lcd();
    
    return 0;
}
